VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CustomLabelCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"CustomLabel"
Attribute VB_Ext_KEY = "Member0" ,"CustomLabel"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mCol As Collection
Private mOwner As Form

Public Sub Initialize(ByVal owner As Form)
    If mOwner Is Nothing Then
        Set mOwner = owner
    Else
        Err.Raise 445
    End If
End Sub

Private Function GetFirstIndex() As Integer
    Dim currentIndex As Integer
    For currentIndex = 1 To mCol.Count
        If mCol(currentIndex).GetLabel() Is Nothing Then
            GetFirstIndex = -currentIndex
            Exit Function
        End If
    Next
    GetFirstIndex = currentIndex
End Function

Private Function CreateLabel(ByVal Index As Integer) As VB.Label
    Dim lbl As Label
    Set lbl = mOwner.Controls.Add("VB.Label", "d_add" & CStr(Index))
    lbl.Caption = lbl.Name
    lbl.Move 400, Index * 360, 720, 240
    lbl.Visible = True
    Set CreateLabel = lbl
End Function

Public Function Add() As CustomLabel
    If mOwner Is Nothing Then
        Err.Raise 5
    End If

    Dim Index As Integer
    Index = GetFirstIndex()

    Dim lbl As Label
    Set lbl = CreateLabel(Abs(Index))
    
    Dim objMember As CustomLabel
    If Index < 0 Then
        Set objMember = mCol(Abs(Index))
    Else
        Set objMember = New CustomLabel
        mCol.Add objMember, lbl.Name
    End If
    Set Add = SetLabel(objMember, lbl)
End Function

Private Function SetLabel(ByVal target As IConstructor, ByVal arg As Variant) As CustomLabel
    target.Initialize arg
    Set SetLabel = target
End Function

Public Property Get Item(ByVal IndexKey As Integer) As CustomLabel
Attribute Item.VB_UserMemId = 0
    Set Item = mCol(vntIndexKey)
End Property

Public Property Get Count() As Long
    Count = mCol.Count
End Property

Private Sub Class_Initialize()
    Set mCol = New Collection
End Sub

Private Sub Class_Terminate()
    Set mCol = Nothing
End Sub

'DISPID_NEWENUM, Hidden
Public Function NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Function

